]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: handle filenames that have directories in them
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 #
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program.  If not, see http://www.gnu.org/licenses/ .
16
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18     echo "Error: The notmuch test suite requires a bash version >= 4.0"
19     echo "due to use of associative arrays within the test suite."
20     echo "Please try again with a newer bash (or help us fix the"
21     echo "test suite to be more portable). Thanks."
22     exit 1
23 fi
24
25 # if --tee was passed, write the output not only to the terminal, but
26 # additionally to the file test-results/$BASENAME.out, too.
27 case "$GIT_TEST_TEE_STARTED, $* " in
28 done,*)
29         # do not redirect again
30         ;;
31 *' --tee '*|*' --va'*)
32         mkdir -p test-results
33         BASE=test-results/$(basename "$0" .sh)
34         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
35          echo $? > $BASE.exit) | tee $BASE.out
36         test "$(cat $BASE.exit)" = 0
37         exit
38         ;;
39 esac
40
41 # Keep the original TERM for say_color and test_emacs
42 ORIGINAL_TERM=$TERM
43
44 # For repeatability, reset the environment to known value.
45 LANG=C
46 LC_ALL=C
47 PAGER=cat
48 TZ=UTC
49 TERM=dumb
50 export LANG LC_ALL PAGER TERM TZ
51 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
52 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$debug"; then
120     print_subtest () {
121         printf " %-4s" "[$((test_count - 1))]"
122     }
123 else
124     print_subtest () {
125         true
126     }
127 fi
128
129 if test -n "$color"; then
130         say_color () {
131                 (
132                 TERM=$ORIGINAL_TERM
133                 export TERM
134                 case "$1" in
135                         error) tput bold; tput setaf 1;; # bold red
136                         skip)  tput bold; tput setaf 2;; # bold green
137                         pass)  tput setaf 2;;            # green
138                         info)  tput setaf 3;;            # brown
139                         *) test -n "$quiet" && return;;
140                 esac
141                 shift
142                 printf " "
143                 printf "$@"
144                 tput sgr0
145                 print_subtest
146                 )
147         }
148 else
149         say_color() {
150                 test -z "$1" && test -n "$quiet" && return
151                 shift
152                 printf " "
153                 printf "$@"
154                 print_subtest
155         }
156 fi
157
158 error () {
159         say_color error "error: $*\n"
160         GIT_EXIT_OK=t
161         exit 1
162 }
163
164 say () {
165         say_color info "$*"
166 }
167
168 test "${test_description}" != "" ||
169 error "Test script did not set test_description."
170
171 if test "$help" = "t"
172 then
173         echo "Tests ${test_description}"
174         exit 0
175 fi
176
177 echo $(basename "$0"): "Testing ${test_description}"
178
179 exec 5>&1
180
181 test_failure=0
182 test_count=0
183 test_fixed=0
184 test_broken=0
185 test_success=0
186
187 die () {
188         code=$?
189         rm -rf "$TEST_TMPDIR"
190         if test -n "$GIT_EXIT_OK"
191         then
192                 exit $code
193         else
194                 echo >&5 "FATAL: Unexpected exit with code $code"
195                 exit 1
196         fi
197 }
198
199 GIT_EXIT_OK=
200 # Note: TEST_TMPDIR *NOT* exported!
201 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
202 trap 'die' EXIT
203
204 test_decode_color () {
205         sed     -e 's/.\[1m/<WHITE>/g' \
206                 -e 's/.\[31m/<RED>/g' \
207                 -e 's/.\[32m/<GREEN>/g' \
208                 -e 's/.\[33m/<YELLOW>/g' \
209                 -e 's/.\[34m/<BLUE>/g' \
210                 -e 's/.\[35m/<MAGENTA>/g' \
211                 -e 's/.\[36m/<CYAN>/g' \
212                 -e 's/.\[m/<RESET>/g'
213 }
214
215 q_to_nul () {
216         perl -pe 'y/Q/\000/'
217 }
218
219 q_to_cr () {
220         tr Q '\015'
221 }
222
223 append_cr () {
224         sed -e 's/$/Q/' | tr Q '\015'
225 }
226
227 remove_cr () {
228         tr '\015' Q | sed -e 's/Q$//'
229 }
230
231 # Generate a new message in the mail directory, with a unique message
232 # ID and subject. The message is not added to the index.
233 #
234 # After this function returns, the filename of the generated message
235 # is available as $gen_msg_filename and the message ID is available as
236 # $gen_msg_id .
237 #
238 # This function supports named parameters with the bash syntax for
239 # assigning a value to an associative array ([name]=value). The
240 # supported parameters are:
241 #
242 #  [dir]=directory/of/choice
243 #
244 #       Generate the message in directory 'directory/of/choice' within
245 #       the mail store. The directory will be created if necessary.
246 #
247 #  [filename]=name
248 #
249 #       Store the message in file 'name'. The default is to store it
250 #       in 'msg-<count>', where <count> is three-digit number of the
251 #       message.
252 #
253 #  [body]=text
254 #
255 #       Text to use as the body of the email message
256 #
257 #  '[from]="Some User <user@example.com>"'
258 #  '[to]="Some User <user@example.com>"'
259 #  '[subject]="Subject of email message"'
260 #  '[date]="RFC 822 Date"'
261 #
262 #       Values for email headers. If not provided, default values will
263 #       be generated instead.
264 #
265 #  '[cc]="Some User <user@example.com>"'
266 #  [reply-to]=some-address
267 #  [in-reply-to]=<message-id>
268 #  [references]=<message-id>
269 #  [content-type]=content-type-specification
270 #  '[header]=full header line, including keyword'
271 #
272 #       Additional values for email headers. If these are not provided
273 #       then the relevant headers will simply not appear in the
274 #       message.
275 #
276 #  '[id]=message-id'
277 #
278 #       Controls the message-id of the created message.
279 gen_msg_cnt=0
280 gen_msg_filename=""
281 gen_msg_id=""
282 generate_message ()
283 {
284     # This is our (bash-specific) magic for doing named parameters
285     local -A template="($@)"
286     local additional_headers
287
288     gen_msg_cnt=$((gen_msg_cnt + 1))
289     if [ -z "${template[filename]}" ]; then
290         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
291     else
292         gen_msg_name=${template[filename]}
293     fi
294
295     if [ -z "${template[id]}" ]; then
296         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
297     else
298         gen_msg_id="${template[id]}"
299     fi
300
301     if [ -z "${template[dir]}" ]; then
302         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
303     else
304         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
305         mkdir -p "$(dirname "$gen_msg_filename")"
306     fi
307
308     if [ -z "${template[body]}" ]; then
309         template[body]="This is just a test message (#${gen_msg_cnt})"
310     fi
311
312     if [ -z "${template[from]}" ]; then
313         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
314     fi
315
316     if [ -z "${template[to]}" ]; then
317         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
318     fi
319
320     if [ -z "${template[subject]}" ]; then
321         if [ -n "$test_subtest_name" ]; then
322             template[subject]="$test_subtest_name"
323         else
324             template[subject]="Test message #${gen_msg_cnt}"
325         fi
326     fi
327
328     if [ -z "${template[date]}" ]; then
329         template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
330     fi
331
332     additional_headers=""
333     if [ ! -z "${template[header]}" ]; then
334         additional_headers="${template[header]}
335 ${additional_headers}"
336     fi
337
338     if [ ! -z "${template[reply-to]}" ]; then
339         additional_headers="Reply-To: ${template[reply-to]}
340 ${additional_headers}"
341     fi
342
343     if [ ! -z "${template[in-reply-to]}" ]; then
344         additional_headers="In-Reply-To: ${template[in-reply-to]}
345 ${additional_headers}"
346     fi
347
348     if [ ! -z "${template[cc]}" ]; then
349         additional_headers="Cc: ${template[cc]}
350 ${additional_headers}"
351     fi
352
353     if [ ! -z "${template[references]}" ]; then
354         additional_headers="References: ${template[references]}
355 ${additional_headers}"
356     fi
357
358     if [ ! -z "${template[content-type]}" ]; then
359         additional_headers="Content-Type: ${template[content-type]}
360 ${additional_headers}"
361     fi
362
363     if [ ! -z "${template[content-transfer-encoding]}" ]; then
364         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
365 ${additional_headers}"
366     fi
367
368     # Note that in the way we're setting it above and using it below,
369     # `additional_headers' will also serve as the header / body separator
370     # (empty line in between).
371
372     cat <<EOF >"$gen_msg_filename"
373 From: ${template[from]}
374 To: ${template[to]}
375 Message-Id: <${gen_msg_id}>
376 Subject: ${template[subject]}
377 Date: ${template[date]}
378 ${additional_headers}
379 ${template[body]}
380 EOF
381 }
382
383 # Generate a new message and add it to the database.
384 #
385 # All of the arguments and return values supported by generate_message
386 # are also supported here, so see that function for details.
387 add_message ()
388 {
389     generate_message "$@" &&
390     notmuch new > /dev/null
391 }
392
393 # Deliver a message with emacs and add it to the database
394 #
395 # Uses emacs to generate and deliver a message to the mail store.
396 # Accepts arbitrary extra emacs/elisp functions to modify the message
397 # before sending, which is useful to doing things like attaching files
398 # to the message and encrypting/signing.
399 emacs_deliver_message ()
400 {
401     local subject="$1"
402     local body="$2"
403     shift 2
404     # before we can send a message, we have to prepare the FCC maildir
405     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
406     $TEST_DIRECTORY/smtp-dummy sent_message &
407     smtp_dummy_pid=$!
408     test_emacs \
409         "(let ((message-send-mail-function 'message-smtpmail-send-it)
410                (smtpmail-smtp-server \"localhost\")
411                (smtpmail-smtp-service \"25025\"))
412            (notmuch-hello)
413            (notmuch-mua-mail)
414            (message-goto-to)
415            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
416            (message-goto-subject)
417            (insert \"${subject}\")
418            (message-goto-body)
419            (insert \"${body}\")
420            $@
421            (message-send-and-exit))"
422     # opportunistically quit smtp-dummy in case above fails.
423     { echo QUIT > /dev/tcp/localhost/25025; } 2>/dev/null
424     wait ${smtp_dummy_pid}
425     notmuch new >/dev/null
426 }
427
428 # Generate a corpus of email and add it to the database.
429 #
430 # This corpus is fixed, (it happens to be 50 messages from early in
431 # the history of the notmuch mailing list), which allows for reliably
432 # testing commands that need to operate on a not-totally-trivial
433 # number of messages.
434 add_email_corpus ()
435 {
436     rm -rf ${MAIL_DIR}
437     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
438         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
439     else
440         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
441         notmuch new >/dev/null
442         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
443     fi
444 }
445
446 test_begin_subtest ()
447 {
448     if [ -n "$inside_subtest" ]; then
449         exec 1>&6 2>&7          # Restore stdout and stderr
450         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
451     fi
452     test_subtest_name="$1"
453     test_reset_state_
454     # Remember stdout and stderr file descriptors and redirect test
455     # output to the previously prepared file descriptors 3 and 4 (see
456     # below)
457     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
458     exec 6>&1 7>&2 >&3 2>&4
459     inside_subtest=t
460 }
461
462 # Pass test if two arguments match
463 #
464 # Note: Unlike all other test_expect_* functions, this function does
465 # not accept a test name. Instead, the caller should call
466 # test_begin_subtest before calling this function in order to set the
467 # name.
468 test_expect_equal ()
469 {
470         exec 1>&6 2>&7          # Restore stdout and stderr
471         inside_subtest=
472         test "$#" = 3 && { prereq=$1; shift; } || prereq=
473         test "$#" = 2 ||
474         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
475
476         output="$1"
477         expected="$2"
478         if ! test_skip "$test_subtest_name"
479         then
480                 if [ "$output" = "$expected" ]; then
481                         test_ok_ "$test_subtest_name"
482                 else
483                         testname=$this_test.$test_count
484                         echo "$expected" > $testname.expected
485                         echo "$output" > $testname.output
486                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
487                 fi
488     fi
489 }
490
491 # Like test_expect_equal, but takes two filenames.
492 test_expect_equal_file ()
493 {
494         exec 1>&6 2>&7          # Restore stdout and stderr
495         inside_subtest=
496         test "$#" = 3 && { prereq=$1; shift; } || prereq=
497         test "$#" = 2 ||
498         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
499
500         file1="$1"
501         basename1=`basename "$file1"`
502         file2="$2"
503         basename2=`basename "$file2"`
504         if ! test_skip "$test_subtest_name"
505         then
506                 if diff -q "$file1" "$file2" >/dev/null ; then
507                         test_ok_ "$test_subtest_name"
508                 else
509                         testname=$this_test.$test_count
510                         cp "$file1" "$testname.$basename1"
511                         cp "$file2" "$testname.$basename2"
512                         test_failure_ "$test_subtest_name" "$(diff -u "$testname.$basename1" "$testname.$basename2")"
513                 fi
514     fi
515 }
516
517 # Like test_expect_equal, but arguments are JSON expressions to be
518 # canonicalized before diff'ing.  If an argument cannot be parsed, it
519 # is used unchanged so that there's something to diff against.
520 test_expect_equal_json () {
521     output=$(echo "$1" | python -mjson.tool || echo "$1")
522     expected=$(echo "$2" | python -mjson.tool || echo "$2")
523     shift 2
524     test_expect_equal "$output" "$expected" "$@"
525 }
526
527 test_emacs_expect_t () {
528         test "$#" = 2 && { prereq=$1; shift; } || prereq=
529         test "$#" = 1 ||
530         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
531
532         # Run the test.
533         if ! test_skip "$test_subtest_name"
534         then
535                 test_emacs "(notmuch-test-run $1)" >/dev/null
536
537                 # Restore state after the test.
538                 exec 1>&6 2>&7          # Restore stdout and stderr
539                 inside_subtest=
540
541                 # Report success/failure.
542                 result=$(cat OUTPUT)
543                 if [ "$result" = t ]
544                 then
545                         test_ok_ "$test_subtest_name"
546                 else
547                         test_failure_ "$test_subtest_name" "${result}"
548                 fi
549         else
550                 # Restore state after the (non) test.
551                 exec 1>&6 2>&7          # Restore stdout and stderr
552                 inside_subtest=
553         fi
554 }
555
556 NOTMUCH_NEW ()
557 {
558     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
559 }
560
561 notmuch_search_sanitize ()
562 {
563     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
564 }
565
566 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
567 notmuch_show_sanitize ()
568 {
569     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
570 }
571 notmuch_show_sanitize_all ()
572 {
573     sed \
574         -e 's| filename:.*| filename:XXXXX|' \
575         -e 's| id:[^ ]* | id:XXXXX |'
576 }
577
578 notmuch_json_show_sanitize ()
579 {
580     sed \
581         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
582         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|g'
583 }
584
585 # End of notmuch helper functions
586
587 # Use test_set_prereq to tell that a particular prerequisite is available.
588 # The prerequisite can later be checked for in two ways:
589 #
590 # - Explicitly using test_have_prereq.
591 #
592 # - Implicitly by specifying the prerequisite tag in the calls to
593 #   test_expect_{success,failure,code}.
594 #
595 # The single parameter is the prerequisite tag (a simple word, in all
596 # capital letters by convention).
597
598 test_set_prereq () {
599         satisfied="$satisfied$1 "
600 }
601 satisfied=" "
602
603 test_have_prereq () {
604         case $satisfied in
605         *" $1 "*)
606                 : yes, have it ;;
607         *)
608                 ! : nope ;;
609         esac
610 }
611
612 # declare prerequisite for the given external binary
613 test_declare_external_prereq () {
614         binary="$1"
615         test "$#" = 2 && name=$2 || name="$binary(1)"
616
617         hash $binary 2>/dev/null || eval "
618         test_missing_external_prereq_${binary}_=t
619 $binary () {
620         echo -n \"\$test_subtest_missing_external_prereqs_ \" | grep -qe \" $name \" ||
621         test_subtest_missing_external_prereqs_=\"\$test_subtest_missing_external_prereqs_ $name\"
622         false
623 }"
624 }
625
626 # Explicitly require external prerequisite.  Useful when binary is
627 # called indirectly (e.g. from emacs).
628 # Returns success if dependency is available, failure otherwise.
629 test_require_external_prereq () {
630         binary="$1"
631         if [ "$(eval echo -n \$test_missing_external_prereq_${binary}_)" = t ]; then
632                 # dependency is missing, call the replacement function to note it
633                 eval "$binary"
634         else
635                 true
636         fi
637 }
638
639 # You are not expected to call test_ok_ and test_failure_ directly, use
640 # the text_expect_* functions instead.
641
642 test_ok_ () {
643         if test "$test_subtest_known_broken_" = "t"; then
644                 test_known_broken_ok_ "$@"
645                 return
646         fi
647         test_success=$(($test_success + 1))
648         say_color pass "%-6s" "PASS"
649         echo " $@"
650 }
651
652 test_failure_ () {
653         if test "$test_subtest_known_broken_" = "t"; then
654                 test_known_broken_failure_ "$@"
655                 return
656         fi
657         test_failure=$(($test_failure + 1))
658         test_failure_message_ "FAIL" "$@"
659         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
660         return 1
661 }
662
663 test_failure_message_ () {
664         say_color error "%-6s" "$1"
665         echo " $2"
666         shift 2
667         echo "$@" | sed -e 's/^/        /'
668         if test "$verbose" != "t"; then cat test.output; fi
669 }
670
671 test_known_broken_ok_ () {
672         test_reset_state_
673         test_fixed=$(($test_fixed+1))
674         say_color pass "%-6s" "FIXED"
675         echo " $@"
676 }
677
678 test_known_broken_failure_ () {
679         test_reset_state_
680         test_broken=$(($test_broken+1))
681         test_failure_message_ "BROKEN" "$@"
682         return 1
683 }
684
685 test_debug () {
686         test "$debug" = "" || eval "$1"
687 }
688
689 test_run_ () {
690         test_cleanup=:
691         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
692         eval >&3 2>&4 "$1"
693         eval_ret=$?
694         eval >&3 2>&4 "$test_cleanup"
695         return 0
696 }
697
698 test_skip () {
699         test_count=$(($test_count+1))
700         to_skip=
701         for skp in $NOTMUCH_SKIP_TESTS
702         do
703                 case $this_test.$test_count in
704                 $skp)
705                         to_skip=t
706                 esac
707         done
708         if test -z "$to_skip" && test -n "$prereq" &&
709            ! test_have_prereq "$prereq"
710         then
711                 to_skip=t
712         fi
713         case "$to_skip" in
714         t)
715                 test_report_skip_ "$@"
716                 ;;
717         *)
718                 test_check_missing_external_prereqs_ "$@"
719                 ;;
720         esac
721 }
722
723 test_check_missing_external_prereqs_ () {
724         if test -n "$test_subtest_missing_external_prereqs_"; then
725                 say_color skip >&1 "missing prerequisites:"
726                 echo "$test_subtest_missing_external_prereqs_" >&1
727                 test_report_skip_ "$@"
728         else
729                 false
730         fi
731 }
732
733 test_report_skip_ () {
734         test_reset_state_
735         say_color skip >&3 "skipping test:"
736         echo " $@" >&3
737         say_color skip "%-6s" "SKIP"
738         echo " $1"
739 }
740
741 test_subtest_known_broken () {
742         test_subtest_known_broken_=t
743 }
744
745 test_expect_success () {
746         test "$#" = 3 && { prereq=$1; shift; } || prereq=
747         test "$#" = 2 ||
748         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
749         test_reset_state_
750         if ! test_skip "$@"
751         then
752                 test_run_ "$2"
753                 run_ret="$?"
754                 # test_run_ may update missing external prerequisites
755                 test_check_missing_external_prereqs_ "$@" ||
756                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
757                 then
758                         test_ok_ "$1"
759                 else
760                         test_failure_ "$@"
761                 fi
762         fi
763 }
764
765 test_expect_code () {
766         test "$#" = 4 && { prereq=$1; shift; } || prereq=
767         test "$#" = 3 ||
768         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
769         test_reset_state_
770         if ! test_skip "$@"
771         then
772                 test_run_ "$3"
773                 run_ret="$?"
774                 # test_run_ may update missing external prerequisites,
775                 test_check_missing_external_prereqs_ "$@" ||
776                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
777                 then
778                         test_ok_ "$2"
779                 else
780                         test_failure_ "$@"
781                 fi
782         fi
783 }
784
785 # test_external runs external test scripts that provide continuous
786 # test output about their progress, and succeeds/fails on
787 # zero/non-zero exit code.  It outputs the test output on stdout even
788 # in non-verbose mode, and announces the external script with "* run
789 # <n>: ..." before running it.  When providing relative paths, keep in
790 # mind that all scripts run in "trash directory".
791 # Usage: test_external description command arguments...
792 # Example: test_external 'Perl API' perl ../path/to/test.pl
793 test_external () {
794         test "$#" = 4 && { prereq=$1; shift; } || prereq=
795         test "$#" = 3 ||
796         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
797         descr="$1"
798         shift
799         test_reset_state_
800         if ! test_skip "$descr" "$@"
801         then
802                 # Announce the script to reduce confusion about the
803                 # test output that follows.
804                 say_color "" " run $test_count: $descr ($*)"
805                 # Run command; redirect its stderr to &4 as in
806                 # test_run_, but keep its stdout on our stdout even in
807                 # non-verbose mode.
808                 "$@" 2>&4
809                 if [ "$?" = 0 ]
810                 then
811                         test_ok_ "$descr"
812                 else
813                         test_failure_ "$descr" "$@"
814                 fi
815         fi
816 }
817
818 # Like test_external, but in addition tests that the command generated
819 # no output on stderr.
820 test_external_without_stderr () {
821         # The temporary file has no (and must have no) security
822         # implications.
823         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
824         stderr="$tmp/git-external-stderr.$$.tmp"
825         test_external "$@" 4> "$stderr"
826         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
827         descr="no stderr: $1"
828         shift
829         if [ ! -s "$stderr" ]; then
830                 rm "$stderr"
831                 test_ok_ "$descr"
832         else
833                 if [ "$verbose" = t ]; then
834                         output=`echo; echo Stderr is:; cat "$stderr"`
835                 else
836                         output=
837                 fi
838                 # rm first in case test_failure exits.
839                 rm "$stderr"
840                 test_failure_ "$descr" "$@" "$output"
841         fi
842 }
843
844 # This is not among top-level (test_expect_success)
845 # but is a prefix that can be used in the test script, like:
846 #
847 #       test_expect_success 'complain and die' '
848 #           do something &&
849 #           do something else &&
850 #           test_must_fail git checkout ../outerspace
851 #       '
852 #
853 # Writing this as "! git checkout ../outerspace" is wrong, because
854 # the failure could be due to a segv.  We want a controlled failure.
855
856 test_must_fail () {
857         "$@"
858         test $? -gt 0 -a $? -le 129 -o $? -gt 192
859 }
860
861 # test_cmp is a helper function to compare actual and expected output.
862 # You can use it like:
863 #
864 #       test_expect_success 'foo works' '
865 #               echo expected >expected &&
866 #               foo >actual &&
867 #               test_cmp expected actual
868 #       '
869 #
870 # This could be written as either "cmp" or "diff -u", but:
871 # - cmp's output is not nearly as easy to read as diff -u
872 # - not all diff versions understand "-u"
873
874 test_cmp() {
875         $GIT_TEST_CMP "$@"
876 }
877
878 # This function can be used to schedule some commands to be run
879 # unconditionally at the end of the test to restore sanity:
880 #
881 #       test_expect_success 'test core.capslock' '
882 #               git config core.capslock true &&
883 #               test_when_finished "git config --unset core.capslock" &&
884 #               hello world
885 #       '
886 #
887 # That would be roughly equivalent to
888 #
889 #       test_expect_success 'test core.capslock' '
890 #               git config core.capslock true &&
891 #               hello world
892 #               git config --unset core.capslock
893 #       '
894 #
895 # except that the greeting and config --unset must both succeed for
896 # the test to pass.
897
898 test_when_finished () {
899         test_cleanup="{ $*
900                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
901 }
902
903 test_done () {
904         GIT_EXIT_OK=t
905         test_results_dir="$TEST_DIRECTORY/test-results"
906         mkdir -p "$test_results_dir"
907         test_results_path="$test_results_dir/${0%.sh}-$$"
908
909         echo "total $test_count" >> $test_results_path
910         echo "success $test_success" >> $test_results_path
911         echo "fixed $test_fixed" >> $test_results_path
912         echo "broken $test_broken" >> $test_results_path
913         echo "failed $test_failure" >> $test_results_path
914         echo "" >> $test_results_path
915
916         echo
917
918         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
919
920         if [ "$test_failure" = "0" ]; then
921             if [ "$test_broken" = "0" ]; then
922                 rm -rf "$remove_tmp"
923             fi
924             exit 0
925         else
926             exit 1
927         fi
928 }
929
930 emacs_generate_script () {
931         # Construct a little test script here for the benefit of the user,
932         # (who can easily run "run_emacs" to get the same emacs environment
933         # for investigating any failures).
934         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
935 #!/bin/sh
936 export PATH=$PATH
937 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
938
939 # Here's what we are using here:
940 #
941 # --no-init-file        Don't load users ~/.emacs
942 #
943 # --no-site-file        Don't load the site-wide startup stuff
944 #
945 # --directory           Ensure that the local elisp sources are found
946 #
947 # --load                Force loading of notmuch.el and test-lib.el
948
949 exec ${TEST_EMACS} --no-init-file --no-site-file \
950         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
951         --directory "$TEST_DIRECTORY" --load test-lib.el \
952         "\$@"
953 EOF
954         chmod a+x "$TMP_DIRECTORY/run_emacs"
955 }
956
957 test_emacs () {
958         # test dependencies beforehand to avoid the waiting loop below
959         missing_dependencies=
960         test_require_external_prereq dtach || missing_dependencies=1
961         test_require_external_prereq emacs || missing_dependencies=1
962         test_require_external_prereq emacsclient || missing_dependencies=1
963         test -z "$missing_dependencies" || return
964
965         if [ -z "$EMACS_SERVER" ]; then
966                 emacs_tests="$(basename $0).el"
967                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
968                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
969                 else
970                         load_emacs_tests=
971                 fi
972                 server_name="notmuch-test-suite-$$"
973                 # start a detached session with an emacs server
974                 # user's TERM is given to dtach which assumes a minimally
975                 # VT100-compatible terminal -- and emacs inherits that
976                 TERM=$ORIGINAL_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
977                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
978                                 --no-window-system \
979                                 $load_emacs_tests \
980                                 --eval '(setq server-name \"$server_name\")' \
981                                 --eval '(server-start)' \
982                                 --eval '(orphan-watchdog $$)'" || return
983                 EMACS_SERVER="$server_name"
984                 # wait until the emacs server is up
985                 until test_emacs '()' >/dev/null 2>/dev/null; do
986                         sleep 1
987                 done
988         fi
989
990         # Clear test-output output file.  Most Emacs tests end with a
991         # call to (test-output).  If the test code fails with an
992         # exception before this call, the output file won't get
993         # updated.  Since we don't want to compare against an output
994         # file from another test, so start out with an empty file.
995         rm -f OUTPUT
996         touch OUTPUT
997
998         emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
999 }
1000
1001 test_python() {
1002         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1003         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1004
1005         # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
1006         # most others as /usr/bin/python. So first try python2, and fallback to
1007         # python if python2 doesn't exist.
1008         cmd=python2
1009         [[ "$test_missing_external_prereq_python2_" = t ]] && cmd=python
1010
1011         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1012                 | $cmd -
1013 }
1014
1015 # Creates a script that counts how much time it is executed and calls
1016 # notmuch.  $notmuch_counter_command is set to the path to the
1017 # generated script.  Use notmuch_counter_value() function to get the
1018 # current counter value.
1019 notmuch_counter_reset () {
1020         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1021         if [ ! -x "$notmuch_counter_command" ]; then
1022                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1023                 cat >"$notmuch_counter_command" <<EOF || return
1024 #!/bin/sh
1025
1026 read count < "$notmuch_counter_state_path"
1027 echo \$((count + 1)) > "$notmuch_counter_state_path"
1028
1029 exec notmuch "\$@"
1030 EOF
1031                 chmod +x "$notmuch_counter_command" || return
1032         fi
1033
1034         echo 0 > "$notmuch_counter_state_path"
1035 }
1036
1037 # Returns the current notmuch counter value.
1038 notmuch_counter_value () {
1039         if [ -r "$notmuch_counter_state_path" ]; then
1040                 read count < "$notmuch_counter_state_path"
1041         else
1042                 count=0
1043         fi
1044         echo $count
1045 }
1046
1047 test_reset_state_ () {
1048         test -z "$test_init_done_" && test_init_
1049
1050         test_subtest_known_broken_=
1051         test_subtest_missing_external_prereqs_=
1052 }
1053
1054 # called once before the first subtest
1055 test_init_ () {
1056         test_init_done_=t
1057
1058         # skip all tests if there were external prerequisites missing during init
1059         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1060 }
1061
1062
1063 find_notmuch_path ()
1064 {
1065     dir="$1"
1066
1067     while [ -n "$dir" ]; do
1068         bin="$dir/notmuch"
1069         if [ -x "$bin" ]; then
1070             echo "$dir"
1071             return
1072         fi
1073         dir="$(dirname "$dir")"
1074         if [ "$dir" = "/" ]; then
1075             break
1076         fi
1077     done
1078 }
1079
1080 # Test the binaries we have just built.  The tests are kept in
1081 # test/ subdirectory and are run in 'trash directory' subdirectory.
1082 TEST_DIRECTORY=$(pwd)
1083 notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
1084 if test -n "$valgrind"
1085 then
1086         make_symlink () {
1087                 test -h "$2" &&
1088                 test "$1" = "$(readlink "$2")" || {
1089                         # be super paranoid
1090                         if mkdir "$2".lock
1091                         then
1092                                 rm -f "$2" &&
1093                                 ln -s "$1" "$2" &&
1094                                 rm -r "$2".lock
1095                         else
1096                                 while test -d "$2".lock
1097                                 do
1098                                         say "Waiting for lock on $2."
1099                                         sleep 1
1100                                 done
1101                         fi
1102                 }
1103         }
1104
1105         make_valgrind_symlink () {
1106                 # handle only executables
1107                 test -x "$1" || return
1108
1109                 base=$(basename "$1")
1110                 symlink_target=$TEST_DIRECTORY/../$base
1111                 # do not override scripts
1112                 if test -x "$symlink_target" &&
1113                     test ! -d "$symlink_target" &&
1114                     test "#!" != "$(head -c 2 < "$symlink_target")"
1115                 then
1116                         symlink_target=$TEST_DIRECTORY/valgrind.sh
1117                 fi
1118                 case "$base" in
1119                 *.sh|*.perl)
1120                         symlink_target=$TEST_DIRECTORY/unprocessed-script
1121                 esac
1122                 # create the link, or replace it if it is out of date
1123                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1124         }
1125
1126         # override notmuch executable in TEST_DIRECTORY/..
1127         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1128         mkdir -p "$GIT_VALGRIND"/bin
1129         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
1130         OLDIFS=$IFS
1131         IFS=:
1132         for path in $PATH
1133         do
1134                 ls "$path"/notmuch 2> /dev/null |
1135                 while read file
1136                 do
1137                         make_valgrind_symlink "$file"
1138                 done
1139         done
1140         IFS=$OLDIFS
1141         PATH=$GIT_VALGRIND/bin:$PATH
1142         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1143         export GIT_VALGRIND
1144         test -n "$notmuch_path" && MANPATH="$notmuch_path/man:$MANPATH"
1145 else # normal case
1146         if test -n "$notmuch_path"
1147                 then
1148                         PATH="$notmuch_path:$PATH"
1149                         MANPATH="$notmuch_path/man:$MANPATH"
1150                 fi
1151 fi
1152 export PATH MANPATH
1153
1154 # Test repository
1155 test="tmp.$(basename "$0" .sh)"
1156 test -n "$root" && test="$root/$test"
1157 case "$test" in
1158 /*) TMP_DIRECTORY="$test" ;;
1159  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1160 esac
1161 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
1162 rm -fr "$test" || {
1163         GIT_EXIT_OK=t
1164         echo >&5 "FATAL: Cannot prepare test area"
1165         exit 1
1166 }
1167
1168 # A temporary home directory is needed by at least:
1169 # - emacs/"Sending a message via (fake) SMTP"
1170 # - emacs/"Reply within emacs"
1171 # - crypto/emacs_deliver_message
1172 export HOME="${TMP_DIRECTORY}/home"
1173 mkdir -p "${HOME}"
1174
1175 MAIL_DIR="${TMP_DIRECTORY}/mail"
1176 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
1177 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
1178
1179 mkdir -p "${test}"
1180 mkdir -p "${MAIL_DIR}"
1181
1182 cat <<EOF >"${NOTMUCH_CONFIG}"
1183 [database]
1184 path=${MAIL_DIR}
1185
1186 [user]
1187 name=Notmuch Test Suite
1188 primary_email=test_suite@notmuchmail.org
1189 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
1190 EOF
1191
1192 emacs_generate_script
1193
1194
1195 # Use -P to resolve symlinks in our working directory so that the cwd
1196 # in subprocesses like git equals our $PWD (for pathname comparisons).
1197 cd -P "$test" || error "Cannot setup test environment"
1198
1199 if test "$verbose" = "t"
1200 then
1201         exec 4>&2 3>&1
1202 else
1203         exec 4>test.output 3>&4
1204 fi
1205
1206 this_test=${0##*/}
1207 for skp in $NOTMUCH_SKIP_TESTS
1208 do
1209         to_skip=
1210         for skp in $NOTMUCH_SKIP_TESTS
1211         do
1212                 case "$this_test" in
1213                 $skp)
1214                         to_skip=t
1215                 esac
1216         done
1217         case "$to_skip" in
1218         t)
1219                 say_color skip >&3 "skipping test $this_test altogether"
1220                 say_color skip "skip all tests in $this_test"
1221                 test_done
1222         esac
1223 done
1224
1225 # Provide an implementation of the 'yes' utility
1226 yes () {
1227         if test $# = 0
1228         then
1229                 y=y
1230         else
1231                 y="$*"
1232         fi
1233
1234         while echo "$y"
1235         do
1236                 :
1237         done
1238 }
1239
1240 # Fix some commands on Windows
1241 case $(uname -s) in
1242 *MINGW*)
1243         # Windows has its own (incompatible) sort and find
1244         sort () {
1245                 /usr/bin/sort "$@"
1246         }
1247         find () {
1248                 /usr/bin/find "$@"
1249         }
1250         sum () {
1251                 md5sum "$@"
1252         }
1253         # git sees Windows-style pwd
1254         pwd () {
1255                 builtin pwd -W
1256         }
1257         # no POSIX permissions
1258         # backslashes in pathspec are converted to '/'
1259         # exec does not inherit the PID
1260         ;;
1261 *)
1262         test_set_prereq POSIXPERM
1263         test_set_prereq BSLASHPSPEC
1264         test_set_prereq EXECKEEPSPID
1265         ;;
1266 esac
1267
1268 test -z "$NO_PERL" && test_set_prereq PERL
1269 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1270
1271 # test whether the filesystem supports symbolic links
1272 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1273 rm -f y
1274
1275 # declare prerequisites for external binaries used in tests
1276 test_declare_external_prereq dtach
1277 test_declare_external_prereq emacs
1278 test_declare_external_prereq emacsclient
1279 test_declare_external_prereq gdb
1280 test_declare_external_prereq gpg
1281 test_declare_external_prereq python
1282 test_declare_external_prereq python2